<P> 
This sample demonstrates how to use Composite objects (created in script) in 
a multithreaded applications on-the-fly. In this case it is an ASP application.
The specifics of this example are that it creates the composite object directly
from its definition file. It is not registered as regular COM class in the system
registry. Therefore without such registration we cannot count on the COM system
to create an apartment for it and we must do this on our own. Failing to do so
will cause failure each time we call the object from a thread different from the
thread in which it was originally created. So if we are going to use the composite
in one page only (e.g. create it during the page processing each time the page is
executed) all these tricks will not be needed, but when we want to create such an
object shared between the pages in our site (e.g. preserve it in the Application or
the Session - as appropriate) we must ensure each call to the object will occur on
its original thread. As it was mentioned above the COM system can do this for us
but only if we register the object as usual in the system registry, on contrary
(for example in pure autorun application) we may want to avoid touching the registry,
thus we cannot benefit of this system service and we must do this task manually.
</P>
<P><B>What happens here?</B><BR>
First step we do in the global.asa file. There we create a COM Apartment and then
we use its creator property to create our composite in the apartment. Keeping the 
COM apartment object in an Application variable ensures it will live as long as the 
Application object lives and the objects created in this apartment will be kept 
functional by sequencing all the calls to them through the apartment object where they
are created.
</P>
<P>Further by clicking the link below you will invoke a frameset page that will open
one page twice and so invoke two concurent calls to our shared composite object. The 
function called executes a long lasting cycle in order to slow the execution and demonstrate
what happens with concurent calls. As you will see the pages will complete one after another.
So, when the first call reaches our object it will begin execution, the second call will wait 
the first one to complete and then it will be processed too. The time the call needs to complete
depends on your system and should be between few seconds and a minute. If your system is slower
(for example under 500MHz) you can edit the component code (in the comp directory) and
decrease the number of empty cycles done.
</P>
<A HREF="callboth.htm">Demo</A>